# -*- coding: UTF-8 -*-

import os
home = os.environ.get('HOME')

import math              as m
import numpy             as np

# from lib_bin import *
def int2hex(n,nbits):
    """ 
    affiche la représentation hexadécimale d'un nombre int avec complément à 2  
    pour les valeurs négatives
    début: 9 janvier 2015
    """
    if (nbits % 4) != 0 :
        return 'ERROR 1!'
    spec='0'+str(nbits/4)+'x'
    if n >= (-2**(nbits-1)) and n <= (2**(nbits-1)-1) :
        return format(n, spec) if n>=0 else format(2**nbits+n, spec)
    else :
        return 'ERROR 2!'

print '######################### SIGNAUX SINUSOÏDAUX ############################'
print '######################### SÉRIE 6             ############################'
print
nbits_wf  = 14+2
min_wf    = -pow(2,nbits_wf-1)
max_wf    = +pow(2,nbits_wf-1)-1
n_fft     = 256
print 'bits for waveforms =', nbits_wf
print 'min value for WF   =', min_wf
print 'max value for WF   =', max_wf
print 'points for FFT     =', n_fft
 
directory = home                + '/DD pc-p-chust/Missions/Solar Orbiter/LFR/Python/Emulator/signaux_fft/'
#directory =  '/WIN/Users/chust/' +      '/DD CHUST/Missions/Solar Orbiter/LFR/Python/Emulator/signaux_fft/' 

ampl_arr = [8,9,10,11,12,13,14,15]
phi_arr = [0., 45., 90.]

for l in xrange(len(ampl_arr)) :
  print
  for j in xrange(len(phi_arr)) :
    ampl = ampl_arr[l]
    nbits_used = 4
    phi = phi_arr[j]
    i_f = 32.5
    f = float(i_f)/n_fft
    t = np.arange(n_fft)
    x = ampl * np.cos(2*m.pi*f*t + phi*m.pi/180)
    x_int16 = np.zeros(n_fft,dtype=np.int16)
    for i in xrange(n_fft) :
        x_int16[i] = int(round(x[i]))
    Xfft = np.fft.fft(x_int16) / len(x_int16)
    
    print 'number of bits used      =', nbits_used    
    print 'i for frequency          =', i_f
    print 'cosine phase             =', phi
    print 'cosine amplitude         =', ampl
    print 'cosine amplitude/2       =', ampl/2.
    print 'cosine amplitude/sqrt(2) =', round(ampl/m.sqrt(2),2)
    print 'sqrt(ampl^2 / 3)         =', np.sqrt(ampl**2. / 3).round(2)
    print 'x_int16 = ', x_int16
    print '     mean(|x_int16|)     =', ( sum(abs(x_int16)) / len(x_int16) ).round(2)
    print 'sqrt(mean(|x_int16|^2))  =', ( np.sqrt(sum(abs(x_int16)**2.)/len(x_int16)) ).round(2)

    filename = 'cos_ampl'+str(int(ampl))+'_freq'+str(i_f)+'_phi'+format(phi,'.1f')+'.dat'    
    f = open(directory+filename, 'w')
    for i in xrange(n_fft) :
        f.write(int2hex(x_int16[i],16))
        f.write('\n')    
    f.close
    print 'this file has been printed: ', filename

    filename = 'FFT_cos_ampl'+str(int(ampl))+'_freq'+str(i_f)+'_phi'+format(phi,'.1f')+'.dat'    
    f = open(directory+filename, 'w')
    for i in xrange(n_fft) :
      f.write(format(Xfft[i],'12f'))
      f.write('\n')    
    f.close
    print 'this file has been printed: ', filename





