# -*- coding: UTF-8 -*-

import os
home = os.environ.get('HOME')
import math              as m

def twos_comp(val, nbits):
    """
    compute the 2's complement of int value val
    http://stackoverflow.com/questions/1604464/twos-complement-in-python
    """
    if (val & (1 << (nbits - 1))) != 0: # if sign bit is set e.g., 8bit: 128-255
        val = val - (1 << nbits)        # compute negative value
    return val     
    
def hex2int(hex_str,nbits):
    """ 
    convertit en int sur nbits, avec complément à 2 pour les valeurs négatives, un string hexadécimale 
    début: 10 février 2015
    """
    return twos_comp(int(hex_str,16), nbits)
    
directory = home                + '/DD pc-p-chust/Missions/Solar Orbiter/LFR/Python/Emulator/signaux_fft/'
#directory =  '/WIN/Users/chust/' +      '/DD CHUST/Missions/Solar Orbiter/LFR/Python/Emulator/signaux_fft/'

print '######################### SIGNAUX SINUSOÏDAUX ############################'
print '######################### ANALYSE SERIE 6     ############################'
print
nbits_wf  = 14+2
min_wf    = -pow(2,nbits_wf-1)
max_wf    = +pow(2,nbits_wf-1)-1
n_fft     = 256
print 'bits for waveforms =', nbits_wf
print 'min value for WF   =', min_wf
print 'max value for WF   =', max_wf
print 'points for FFT     =', n_fft

directory = directory + "série6/"
ampl_arr = [8,9,10,11,12,13,14,15]
phi_arr = [0., 45., 90.]
i_f = 32.5

for l in xrange(len(ampl_arr)) :
  print
  for j in xrange(len(phi_arr)) :
    ampl = ampl_arr[l]
    phi = phi_arr[j]   
    filename = 'cos_ampl'+str(int(ampl))+'_freq'+str(i_f)+'_phi'+format(phi,'.1f')+'.dat'    
    print 'i for frequency          =', i_f
    print 'cosine phase             =', phi
    print 'cosine amplitude         =', ampl
    print 'cosine amplitude/sqrt(2) =', round(ampl/m.sqrt(2),2)
    print 'cosine amplitude/2       =', ampl/2.
    filename_in1 =  filename+'.FFT_output'    
    f_in1 = open(directory+filename_in1, 'r')
    filename_out = filename_in1+'_analyse'
    f_out = open(directory+filename_out, 'w') 
    filename_in2 = 'FFT_'+filename    
    f_in2 = open(directory+filename_in2, 'r')

    max_diff_re = 0.
    max_diff_im = 0.
    ave_diff_re = 0.
    ave_diff_im = 0.
    ave_diff_re2 = 0.
    ave_diff_im2 = 0. 
    nfreq = 0 
    for (line1, line2) in zip(f_in1, f_in2):
      line1 = line1.strip()  # get rid of the \n (and \r) character
      im = line1[:4]
      re = line1[4:]
      re_int = hex2int(re,16)
      im_int = hex2int(im,16)
      #print 'RE: {0:4}  IM: {1:4}'.format(re, im)
      #f_out.write('RE: {0:4}  IM: {1:4}\n'.format(re, im)) 
      line2 = line2.strip()  # get rid of the \n (and \r) character
      cplx = complex(line2)
      diff_re = re_int-cplx.real
      diff_im = im_int-cplx.imag
      #print cplx, cplx.real, cplx.imag
      f_out.write('FFT_VHDL: {0:6d} {1:6d}j  |  FFT_PC: {2:10.2f} {3:10.2f}j  =>  DIFF: {4:10.2f} {5:10.2f}j\n'
                  .format(re_int, im_int, cplx.real, cplx.imag, diff_re, diff_im))
      if abs(diff_re) > max_diff_re :
        max_diff_re = abs(diff_re)
      if abs(diff_im) > max_diff_im :
        max_diff_im = abs(diff_im)
      ave_diff_re += diff_re
      ave_diff_im += diff_im
      ave_diff_re2 += diff_re**2
      ave_diff_im2 += diff_im**2
      nfreq += 1    
    ave_diff_re /= nfreq
    ave_diff_im /= nfreq
    ave_diff_re2 /= nfreq
    ave_diff_im2 /= nfreq  
    gma_diff_re = m.sqrt(ave_diff_re2 - ave_diff_re**2)
    gma_diff_im = m.sqrt(ave_diff_im2 - ave_diff_im**2)  
    f_out.write('{0:52}MAX     |DIFF|   : {1:10.2f} {2:10.2f}j\n'.format('',max_diff_re, max_diff_im)) 
    f_out.write('{0:52}AVE Sqrt(DIFF^2) : {1:10.2f} {2:10.2f}j\n'.format('',m.sqrt(ave_diff_re2), m.sqrt(ave_diff_im2)))
    f_out.write('{0:52}AVE      DIFF    : {1:10.2f} {2:10.2f}j\n'.format('',ave_diff_re, ave_diff_im))
    f_out.write('{0:52}GMA      DIFF    : {1:10.2f} {2:10.2f}j\n'.format('',gma_diff_re, gma_diff_im))
    print '{0:}MAX     |DIFF|   : {1:10.2f} {2:10.2f}j'.format('',max_diff_re, max_diff_im)
    print '{0:}AVE Sqrt(DIFF^2) : {1:10.2f} {2:10.2f}j'.format('',m.sqrt(ave_diff_re2), m.sqrt(ave_diff_im2))
    print '{0:}AVE      DIFF    : {1:10.2f} {2:10.2f}j'.format('',ave_diff_re, ave_diff_im)
    print '{0:}GMA      DIFF    : {1:10.2f} {2:10.2f}j'.format('',gma_diff_re, gma_diff_im)
    f_out.write('{0:52}cosine amplitude/2     = {1:10.2f}\n'.format('',ampl / 2.)) 
    f_in1.close()
    f_in2.close()
    f_out.close() 
    print 'nfreq :', nfreq
    print 'this file has been printed: ', filename_out
      
    
    
    
    
    
    
    
    
    
    
    
  


