# -*- coding: UTF-8 -*-

import os
home = os.environ.get('HOME')
import math              as m

def twos_comp(val, nbits):
    """
    compute the 2's complement of int value val
    http://stackoverflow.com/questions/1604464/twos-complement-in-python
    """
    if (val & (1 << (nbits - 1))) != 0: # if sign bit is set e.g., 8bit: 128-255
        val = val - (1 << nbits)        # compute negative value
    return val     
    
def hex2int(hex_str,nbits):
    """ 
    convertit en int sur nbits, avec complément à 2 pour les valeurs négatives, un string hexadécimale 
    début: 10 février 2015
    """
    return twos_comp(int(hex_str,16), nbits)
    
directory = home                + '/DD pc-p-chust/Missions/Solar Orbiter/LFR/Python/Emulator/signaux_fft/'
#directory =  '/WIN/Users/chust/' +      '/DD CHUST/Missions/Solar Orbiter/LFR/Python/Emulator/signaux_fft/'

print '######################### BRUIT BLANC LARGE BANDE #######################'
print '######################### ANALYSE SERIE 7         #######################'
print
nbits_wf  = 14+2
min_wf    = -pow(2,nbits_wf-1)
max_wf    = +pow(2,nbits_wf-1)-1
n_fft     = 256
print 'bits for waveforms =', nbits_wf
print 'min value for WF   =', min_wf
print 'max value for WF   =', max_wf
print 'points for FFT     =', n_fft

directory = directory + "série7/"
ampl_arr = [int(round(16. * m.sqrt(3)))*2, 2**8, 2**12, pow(2,15)-1]

for l in xrange(len(ampl_arr)) :
  print
  ampl = ampl_arr[l]
  filename = 'noise_ampl'+str(int(ampl))+'.dat' 
  print 'filename   =', filename
  print 'sqrt(ampl^2 / 3)       =', round(m.sqrt(ampl**2. / 3),2)
  print 'sqrt(ampl^2 / 3) / 16  =', round(m.sqrt(ampl**2. / 3)/16,2)
  filename_in1 =  filename+'.FFT_output'    
  f_in1 = open(directory+filename_in1, 'r')
  filename_out = filename_in1+'_analyse'
  f_out = open(directory+filename_out, 'w') 
  filename_in2 = 'FFT_'+filename    
  f_in2 = open(directory+filename_in2, 'r')
  
  max_diff_re = 0.
  max_diff_im = 0.
  for (line1, line2) in zip(f_in1, f_in2):
    line1 = line1.strip()  # get rid of the \n (and \r) character
    im = line1[:4]
    re = line1[4:]
    re_int = hex2int(re,16)
    im_int = hex2int(im,16)
    #print 'RE: {0:4}  IM: {1:4}'.format(re, im)
    #f_out.write('RE: {0:4}  IM: {1:4}\n'.format(re, im)) 
    line2 = line2.strip()  # get rid of the \n (and \r) character
    cplx = complex(line2)
    diff_re = re_int-cplx.real
    diff_im = im_int-cplx.imag
    #print cplx, cplx.real, cplx.imag
    f_out.write('FFT_VHDL: {0:6d} {1:6d}j  |  FFT_PC: {2:10.2f} {3:10.2f}j  =>  DIFF: {4:10.2f} {5:10.2f}j\n'
                  .format(re_int, im_int, cplx.real, cplx.imag, diff_re, diff_im))
    if abs(diff_re) > max_diff_re :
      max_diff_re = abs(diff_re)
    if abs(diff_im) > max_diff_im :
      max_diff_im = abs(diff_im)
  f_out.write('{0:59}MAX |DIFF|: {1:10.2f} {2:10.2f}j\n'.format('',max_diff_re, max_diff_im)) 
  print '{0:}MAX |DIFF|: {1:10.2f} {2:10.2f}j'.format('',max_diff_re, max_diff_im)
  f_out.write('{0:59}sqrt(ampl^2 / 3)       = {1:10.2f}\n'.format('',m.sqrt(ampl**2. / 3))) 
  f_out.write('{0:59}sqrt(ampl^2 / 3) / 16  = {1:10.2f}\n'.format('',m.sqrt(ampl**2. / 3)/16))   
  f_in1.close
  f_in2.close
  f_out.close
      
    
    
    
    
    
    
    
    
    
    
    
  


