# -*- coding: UTF-8 -*-

import os
home = os.environ.get('HOME')

import math              as m
import numpy             as np

# from lib_bin import *
def int2hex(n,nbits):
    """ 
    affiche la représentation hexadécimale d'un nombre int avec complément à 2  
    pour les valeurs négatives
    début: 9 janvier 2015
    """
    if (nbits % 4) != 0 :
        return 'ERROR 1!'
    spec='0'+str(nbits/4)+'x'
    if n >= (-2**(nbits-1)) and n <= (2**(nbits-1)-1) :
        return format(n, spec) if n>=0 else format(2**nbits+n, spec)
    else :
        return 'ERROR 2!'

print '######################### SOMME DE 2 SIGNAUX SINUSOÏDAUX #################'
print '######################### SÉRIE 8                        #################'
print
nbits_wf  = 14+2
min_wf    = -pow(2,nbits_wf-1)
max_wf    = +pow(2,nbits_wf-1)-1
n_fft     = 256
print 'bits for waveforms =', nbits_wf
print 'min value for WF   =', min_wf
print 'max value for WF   =', max_wf
print 'points for FFT     =', n_fft
 
#directory = home                + '/DD pc-p-chust/Missions/Solar Orbiter/LFR/Python/Emulator/signaux_fft/'
directory =  '/WIN/Users/chust/' +      '/DD CHUST/Missions/Solar Orbiter/LFR/Python/Emulator/signaux_fft/' 

t = np.arange(n_fft)
i_f1  = 32.5
ampl1 = 16
phi1  = 0.
f1 = float(i_f1)/n_fft 
x1 = ampl1 * np.cos(2*m.pi*f1*t + phi1*m.pi/180)

i_f2  = 68
ampl2_arr = [16, 256, 4096, 16384, 32751]
phi2_arr  = [0., 45., 90.]
f2 = float(i_f2)/n_fft 

for l in xrange(len(ampl2_arr)) :
  print
  for j in xrange(len(phi2_arr)) :
  
    ampl2 = ampl2_arr[l]
    phi2 = phi2_arr[j]
    x2 = ampl2 * np.cos(2*m.pi*f2*t + phi2*m.pi/180)
    x = x1 + x2
    x_int16 = np.zeros(n_fft,dtype=np.int16)    
    for i in xrange(n_fft) :
        x_int16[i] = int(round(x[i]))
    Xfft = np.fft.fft(x_int16) / len(x_int16)        
    
    print 'i for frequency1         =', i_f1
    print 'cosine phase1            =', phi1
    print 'cosine amplitude1        =', ampl1
    print 'cosine amplitude1/2      =', ampl1/2.
    print 'i for frequency2         =', i_f2
    print 'cosine phase2            =', phi2
    print 'cosine amplitude2        =', ampl2
    print 'cosine amplitude2/2      =', ampl2/2.    
    print 'x_int16 = ', x_int16
    print '     mean(|x_int16|)     =', ( sum(abs(x_int16)) / len(x_int16) ).round(2)
    print 'sqrt(mean(|x_int16|^2))  =', ( np.sqrt(sum(abs(x_int16)**2.)/len(x_int16)) ).round(2)

    filename = 'cos_ampl'+str(int(ampl1))+'_freq'+str(i_f1)+'_phi'+format(phi1,'.1f')+ \
               'cos_ampl'+str(int(ampl2))+'_freq'+str(i_f2)+'_phi'+format(phi2,'.1f')+'.dat'    
    f = open(directory+filename, 'w')
    for i in xrange(n_fft) :
        f.write(int2hex(x_int16[i],16))
        f.write('\n')    
    f.close
    print 'this file has been printed: ', filename

    filename2 = 'FFT_' + filename    
    file2 = open(directory+filename2, 'w')
    for i in xrange(n_fft) :
      file2.write(format(Xfft[i],'12f'))
      file2.write('\n')    
    file2.close
    print 'this file has been printed: ', filename2





